import{s as On,o as Vn,n as mn}from"../chunks/scheduler.f6319a2a.js";import{S as zn,i as Un,g as r,s as a,r as m,A as Hn,h as l,f as n,c as s,j as b,u as p,x as _,k as x,y as e,a as i,v as d,d as c,t as u,w as h}from"../chunks/index.85aa684c.js";import{T as Nn}from"../chunks/Tip.3d397a88.js";import{D as C,E as jn}from"../chunks/ExampleCodeBlock.1f6e6c52.js";import{C as Fn}from"../chunks/CodeBlock.97b48fd2.js";import{H as Yt,E as Gn}from"../chunks/EditOnGithub.006048dd.js";function Rn(E){let g,M=`Smolagents is an experimental API which is subject to change at any time. Results returned by the agents
can vary as the APIs or underlying models are prone to change.`;return{c(){g=r("p"),g.textContent=M},l($){g=l($,"P",{"data-svelte-h":!0}),_(g)!=="svelte-19v5hvw"&&(g.textContent=M)},m($,A){i($,g,A)},p:mn,d($){$&&n(g)}}}function Wn(E){let g,M="Example:",$,A,w;return A=new Fn({props:{code:"ZnJvbSUyMHNtb2xhZ2VudHMlMjBpbXBvcnQlMjBDb2RlQWdlbnQlMEFhZ2VudCUyMCUzRCUyMENvZGVBZ2VudCh0b29scyUzRCU1QiU1RCklMEFhZ2VudC5ydW4oJTIyV2hhdCUyMGlzJTIwdGhlJTIwcmVzdWx0JTIwb2YlMjAyJTIwcG93ZXIlMjAzLjczODQlM0YlMjIp",highlighted:`<span class="hljs-keyword">from</span> smolagents <span class="hljs-keyword">import</span> CodeAgent
agent = CodeAgent(tools=[])
agent.run(<span class="hljs-string">&quot;What is the result of 2 power 3.7384?&quot;</span>)`,wrap:!1}}),{c(){g=r("p"),g.textContent=M,$=a(),m(A.$$.fragment)},l(y){g=l(y,"P",{"data-svelte-h":!0}),_(g)!=="svelte-11lpom8"&&(g.textContent=M),$=s(y),p(A.$$.fragment,y)},m(y,L){i(y,g,L),i(y,$,L),d(A,y,L),w=!0},p:mn,i(y){w||(c(A.$$.fragment,y),w=!0)},o(y){u(A.$$.fragment,y),w=!1},d(y){y&&(n(g),n($)),h(A,y)}}}function Bn(E){let g,M="You must have <code>gradio</code> installed to use the UI. Please run <code>pip install smolagents[gradio]</code> if it’s not the case.";return{c(){g=r("p"),g.innerHTML=M},l($){g=l($,"P",{"data-svelte-h":!0}),_(g)!=="svelte-1fnubjx"&&(g.innerHTML=M)},m($,A){i($,g,A)},p:mn,d($){$&&n(g)}}}function Jn(E){let g,M,$,A,w,y,L,Kt,Z,pn=`To learn more about agents and tools make sure to read the <a href="../index">introductory guide</a>. This page
contains the API docs for the underlying classes.`,te,Q,ee,Y,dn='Our agents inherit from <a href="/docs/smolagents/pr_459/en/reference/agents#smolagents.MultiStepAgent">MultiStepAgent</a>, which means they can act in multiple steps, each step consisting of one thought, then one tool call and execution. Read more in <a href="../conceptual_guides/react">this conceptual guide</a>.',ne,X,cn="We provide two types of agents, based on the main <code>Agent</code> class.",ae,K,un='<li><a href="/docs/smolagents/pr_459/en/reference/agents#smolagents.CodeAgent">CodeAgent</a> is the default agent, it writes its tool calls in Python code.</li> <li><a href="/docs/smolagents/pr_459/en/reference/agents#smolagents.ToolCallingAgent">ToolCallingAgent</a> writes its tool calls in JSON.</li>',se,tt,hn="Both require arguments <code>model</code> and list of tools <code>tools</code> at initialization.",oe,et,re,f,nt,Se,Lt,fn=`Agent class that solves the given task step by step, using the ReAct framework:
While the objective is not reached, the agent will perform a cycle of action (given by the LLM) and observation (obtained from the environment).`,De,N,at,Pe,kt,_n=`Execute tool with the provided input and returns the result.
This method replaces arguments with the actual values from the state if they refer to state variables.`,Ie,O,st,Ee,Tt,vn="Parse action from the LLM output",Ne,V,ot,Oe,St,$n="Used periodically by the agent to plan the next steps to reach the objective.",Ve,z,rt,ze,Dt,bn="Provide the final answer to the task, based on the logs of the agent’s interactions.",Ue,U,lt,He,Pt,xn="Prints a pretty replay of the agent’s steps.",je,P,it,Fe,It,yn="Run the agent for the given task.",Ge,H,Re,j,gt,We,Et,Cn="To be implemented in children classes. Should return either None if the step is not final.",Be,F,mt,Je,Nt,An="Creates a rich tree visualization of the agent’s structure.",qe,G,pt,Ze,Ot,Mn=`Reads past llm_outputs, actions, and observations or errors from the memory into a series of messages
that can be used as input to the LLM. Adds a number of keywords (such as PLAN, error, etc) to help
the LLM.`,le,k,dt,Qe,Vt,wn="In this agent, the tool calls will be formulated by the LLM in code format, then parsed and executed.",Ye,R,ct,Xe,zt,Ln=`Perform one step in the ReAct framework: the agent thinks, acts, and observes the result.
Returns None if the step is not final.`,ie,T,ut,Ke,Ut,kn="This agent uses JSON-like tool calls, using method <code>model.get_tool_call</code> to leverage the LLM engine’s tool calling capabilities.",tn,W,ht,en,Ht,Tn=`Perform one step in the ReAct framework: the agent thinks, acts, and observes the result.
Returns None if the step is not final.`,ge,ft,me,S,_t,nn,jt,Sn="ManagedAgent class that manages an agent and provides additional prompting and run summaries.",an,B,vt,sn,Ft,Dn="Adds additional prompting for the managed agent, like ‘add more detail in your answer’.",pe,$t,de,I,bt,on,Gt,Pn="Runs an agent with the given task and streams the messages from the agent as gradio ChatMessages.",ce,xt,ue,J,he,D,yt,rn,Rt,In="A one-line interface to launch your agent in Gradio",ln,q,Ct,gn,Wt,En="Handle file uploads, default allowed types are .pdf, .docx, and .txt",fe,At,_e,Xt,ve;return w=new Yt({props:{title:"Agents",local:"agents",headingTag:"h1"}}),L=new Nn({props:{warning:!0,$$slots:{default:[Rn]},$$scope:{ctx:E}}}),Q=new Yt({props:{title:"Agents",local:"agents",headingTag:"h2"}}),et=new Yt({props:{title:"Classes of agents",local:"smolagents.MultiStepAgent",headingTag:"h3"}}),nt=new C({props:{name:"class smolagents.MultiStepAgent",anchor:"smolagents.MultiStepAgent",parameters:[{name:"tools",val:": typing.List[smolagents.tools.Tool]"},{name:"model",val:": typing.Callable[[typing.List[typing.Dict[str, str]]], smolagents.models.ChatMessage]"},{name:"system_prompt",val:": typing.Optional[str] = None"},{name:"tool_description_template",val:": typing.Optional[str] = None"},{name:"max_steps",val:": int = 6"},{name:"tool_parser",val:": typing.Optional[typing.Callable] = None"},{name:"add_base_tools",val:": bool = False"},{name:"verbosity_level",val:": int = 1"},{name:"grammar",val:": typing.Optional[typing.Dict[str, str]] = None"},{name:"managed_agents",val:": typing.Optional[typing.List] = None"},{name:"step_callbacks",val:": typing.Optional[typing.List[typing.Callable]] = None"},{name:"planning_interval",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.tools",description:'<strong>tools</strong> (<code>list[Tool]</code>) &#x2014; <a href="/docs/smolagents/pr_459/en/reference/tools#smolagents.Tool">Tool</a>s that the agent can use.',name:"tools"},{anchor:"smolagents.MultiStepAgent.model",description:"<strong>model</strong> (<code>Callable[[list[dict[str, str]]], ChatMessage]</code>) &#x2014; Model that will generate the agent&#x2019;s actions.",name:"model"},{anchor:"smolagents.MultiStepAgent.system_prompt",description:"<strong>system_prompt</strong> (<code>str</code>, <em>optional</em>) &#x2014; System prompt that will be used to generate the agent&#x2019;s actions.",name:"system_prompt"},{anchor:"smolagents.MultiStepAgent.tool_description_template",description:"<strong>tool_description_template</strong> (<code>str</code>, <em>optional</em>) &#x2014; Template used to describe the tools in the system prompt.",name:"tool_description_template"},{anchor:"smolagents.MultiStepAgent.max_steps",description:"<strong>max_steps</strong> (<code>int</code>, default <code>6</code>) &#x2014; Maximum number of steps the agent can take to solve the task.",name:"max_steps"},{anchor:"smolagents.MultiStepAgent.tool_parser",description:"<strong>tool_parser</strong> (<code>Callable</code>, <em>optional</em>) &#x2014; Function used to parse the tool calls from the LLM output.",name:"tool_parser"},{anchor:"smolagents.MultiStepAgent.add_base_tools",description:"<strong>add_base_tools</strong> (<code>bool</code>, default <code>False</code>) &#x2014; Whether to add the base tools to the agent&#x2019;s tools.",name:"add_base_tools"},{anchor:"smolagents.MultiStepAgent.verbosity_level",description:"<strong>verbosity_level</strong> (<code>int</code>, default <code>1</code>) &#x2014; Level of verbosity of the agent&#x2019;s logs.",name:"verbosity_level"},{anchor:"smolagents.MultiStepAgent.grammar",description:"<strong>grammar</strong> (<code>dict[str, str]</code>, <em>optional</em>) &#x2014; Grammar used to parse the LLM output.",name:"grammar"},{anchor:"smolagents.MultiStepAgent.managed_agents",description:"<strong>managed_agents</strong> (<code>list</code>, <em>optional</em>) &#x2014; Managed agents that the agent can call.",name:"managed_agents"},{anchor:"smolagents.MultiStepAgent.step_callbacks",description:"<strong>step_callbacks</strong> (<code>list[Callable]</code>, <em>optional</em>) &#x2014; Callbacks that will be called at each step.",name:"step_callbacks"},{anchor:"smolagents.MultiStepAgent.planning_interval",description:"<strong>planning_interval</strong> (<code>int</code>, <em>optional</em>) &#x2014; Interval at which the agent will run a planning step.",name:"planning_interval"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L125"}}),at=new C({props:{name:"execute_tool_call",anchor:"smolagents.MultiStepAgent.execute_tool_call",parameters:[{name:"tool_name",val:": str"},{name:"arguments",val:": typing.Union[typing.Dict[str, str], str]"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.execute_tool_call.tool_name",description:"<strong>tool_name</strong> (<code>str</code>) &#x2014; Name of the Tool to execute (should be one from self.tools).",name:"tool_name"},{anchor:"smolagents.MultiStepAgent.execute_tool_call.arguments",description:"<strong>arguments</strong> (Dict[str, str]) &#x2014; Arguments passed to the Tool.",name:"arguments"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L310"}}),st=new C({props:{name:"extract_action",anchor:"smolagents.MultiStepAgent.extract_action",parameters:[{name:"model_output",val:": str"},{name:"split_token",val:": str"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.extract_action.model_output",description:"<strong>model_output</strong> (<code>str</code>) &#x2014; Output of the LLM",name:"model_output"},{anchor:"smolagents.MultiStepAgent.extract_action.split_token",description:"<strong>split_token</strong> (<code>str</code>) &#x2014; Separator for the action. Should match the example in the system prompt.",name:"split_token"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L232"}}),ot=new C({props:{name:"planning_step",anchor:"smolagents.MultiStepAgent.planning_step",parameters:[{name:"task",val:""},{name:"is_first_step",val:": bool"},{name:"step",val:": int"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.planning_step.task",description:"<strong>task</strong> (<code>str</code>) &#x2014; Task to perform.",name:"task"},{anchor:"smolagents.MultiStepAgent.planning_step.is_first_step",description:"<strong>is_first_step</strong> (<code>bool</code>) &#x2014; If this step is not the first one, the plan should be an update over a previous plan.",name:"is_first_step"},{anchor:"smolagents.MultiStepAgent.planning_step.step",description:"<strong>step</strong> (<code>int</code>) &#x2014; The number of the current step, used as an indication for the LLM.",name:"step"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L488"}}),rt=new C({props:{name:"provide_final_answer",anchor:"smolagents.MultiStepAgent.provide_final_answer",parameters:[{name:"task",val:": str"},{name:"images",val:": typing.Optional[list[str]]"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.provide_final_answer.task",description:"<strong>task</strong> (<code>str</code>) &#x2014; Task to perform.",name:"task"},{anchor:"smolagents.MultiStepAgent.provide_final_answer.images",description:"<strong>images</strong> (<code>list[str]</code>, <em>optional</em>) &#x2014; Paths to image(s).",name:"images"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L253",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Final answer to the task.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>str</code></p>
`}}),lt=new C({props:{name:"replay",anchor:"smolagents.MultiStepAgent.replay",parameters:[{name:"detailed",val:": bool = False"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.replay.detailed",description:`<strong>detailed</strong> (bool, optional) &#x2014; If True, also displays the memory at each step. Defaults to False.
Careful: will increase log length exponentially. Use only for debugging.`,name:"detailed"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L632"}}),it=new C({props:{name:"run",anchor:"smolagents.MultiStepAgent.run",parameters:[{name:"task",val:": str"},{name:"stream",val:": bool = False"},{name:"reset",val:": bool = True"},{name:"single_step",val:": bool = False"},{name:"images",val:": typing.Optional[typing.List[str]] = None"},{name:"additional_args",val:": typing.Optional[typing.Dict] = None"}],parametersDescription:[{anchor:"smolagents.MultiStepAgent.run.task",description:"<strong>task</strong> (<code>str</code>) &#x2014; Task to perform.",name:"task"},{anchor:"smolagents.MultiStepAgent.run.stream",description:"<strong>stream</strong> (<code>bool</code>) &#x2014; Whether to run in a streaming way.",name:"stream"},{anchor:"smolagents.MultiStepAgent.run.reset",description:"<strong>reset</strong> (<code>bool</code>) &#x2014; Whether to reset the conversation or keep it going from previous run.",name:"reset"},{anchor:"smolagents.MultiStepAgent.run.single_step",description:"<strong>single_step</strong> (<code>bool</code>) &#x2014; Whether to run the agent in one-shot fashion.",name:"single_step"},{anchor:"smolagents.MultiStepAgent.run.images",description:"<strong>images</strong> (<code>list[str]</code>, <em>optional</em>) &#x2014; Paths to image(s).",name:"images"},{anchor:"smolagents.MultiStepAgent.run.additional_args",description:"<strong>additional_args</strong> (<code>dict</code>) &#x2014; Any other variables that you want to pass to the agent run, for instance images or dataframes. Give them clear names!",name:"additional_args"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L361"}}),H=new jn({props:{anchor:"smolagents.MultiStepAgent.run.example",$$slots:{default:[Wn]},$$scope:{ctx:E}}}),gt=new C({props:{name:"step",anchor:"smolagents.MultiStepAgent.step",parameters:[{name:"memory_step",val:": ActionStep"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L357"}}),mt=new C({props:{name:"visualize",anchor:"smolagents.MultiStepAgent.visualize",parameters:[],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L228"}}),pt=new C({props:{name:"write_memory_to_messages",anchor:"smolagents.MultiStepAgent.write_memory_to_messages",parameters:[{name:"summary_mode",val:": typing.Optional[bool] = False"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L214"}}),dt=new C({props:{name:"class smolagents.CodeAgent",anchor:"smolagents.CodeAgent",parameters:[{name:"tools",val:": typing.List[smolagents.tools.Tool]"},{name:"model",val:": typing.Callable[[typing.List[typing.Dict[str, str]]], smolagents.models.ChatMessage]"},{name:"system_prompt",val:": typing.Optional[str] = None"},{name:"grammar",val:": typing.Optional[typing.Dict[str, str]] = None"},{name:"additional_authorized_imports",val:": typing.Optional[typing.List[str]] = None"},{name:"planning_interval",val:": typing.Optional[int] = None"},{name:"use_e2b_executor",val:": bool = False"},{name:"max_print_outputs_length",val:": typing.Optional[int] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"smolagents.CodeAgent.tools",description:'<strong>tools</strong> (<code>list[Tool]</code>) &#x2014; <a href="/docs/smolagents/pr_459/en/reference/tools#smolagents.Tool">Tool</a>s that the agent can use.',name:"tools"},{anchor:"smolagents.CodeAgent.model",description:"<strong>model</strong> (<code>Callable[[list[dict[str, str]]], ChatMessage]</code>) &#x2014; Model that will generate the agent&#x2019;s actions.",name:"model"},{anchor:"smolagents.CodeAgent.system_prompt",description:"<strong>system_prompt</strong> (<code>str</code>, <em>optional</em>) &#x2014; System prompt that will be used to generate the agent&#x2019;s actions.",name:"system_prompt"},{anchor:"smolagents.CodeAgent.grammar",description:"<strong>grammar</strong> (<code>dict[str, str]</code>, <em>optional</em>) &#x2014; Grammar used to parse the LLM output.",name:"grammar"},{anchor:"smolagents.CodeAgent.additional_authorized_imports",description:"<strong>additional_authorized_imports</strong> (<code>list[str]</code>, <em>optional</em>) &#x2014; Additional authorized imports for the agent.",name:"additional_authorized_imports"},{anchor:"smolagents.CodeAgent.planning_interval",description:"<strong>planning_interval</strong> (<code>int</code>, <em>optional</em>) &#x2014; Interval at which the agent will run a planning step.",name:"planning_interval"},{anchor:"smolagents.CodeAgent.use_e2b_executor",description:"<strong>use_e2b_executor</strong> (<code>bool</code>, default <code>False</code>) &#x2014; Whether to use the E2B executor for remote code execution.",name:"use_e2b_executor"},{anchor:"smolagents.CodeAgent.max_print_outputs_length",description:"<strong>max_print_outputs_length</strong> (<code>int</code>, <em>optional</em>) &#x2014; Maximum length of the print outputs.",name:"max_print_outputs_length"},{anchor:"smolagents.CodeAgent.*kwargs",description:"*<strong>*kwargs</strong> &#x2014; Additional keyword arguments.",name:"*kwargs"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L757"}}),ct=new C({props:{name:"step",anchor:"smolagents.CodeAgent.step",parameters:[{name:"memory_step",val:": ActionStep"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L838"}}),ut=new C({props:{name:"class smolagents.ToolCallingAgent",anchor:"smolagents.ToolCallingAgent",parameters:[{name:"tools",val:": typing.List[smolagents.tools.Tool]"},{name:"model",val:": typing.Callable[[typing.List[typing.Dict[str, str]]], smolagents.models.ChatMessage]"},{name:"system_prompt",val:": typing.Optional[str] = None"},{name:"planning_interval",val:": typing.Optional[int] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"smolagents.ToolCallingAgent.tools",description:'<strong>tools</strong> (<code>list[Tool]</code>) &#x2014; <a href="/docs/smolagents/pr_459/en/reference/tools#smolagents.Tool">Tool</a>s that the agent can use.',name:"tools"},{anchor:"smolagents.ToolCallingAgent.model",description:"<strong>model</strong> (<code>Callable[[list[dict[str, str]]], ChatMessage]</code>) &#x2014; Model that will generate the agent&#x2019;s actions.",name:"model"},{anchor:"smolagents.ToolCallingAgent.system_prompt",description:"<strong>system_prompt</strong> (<code>str</code>, <em>optional</em>) &#x2014; System prompt that will be used to generate the agent&#x2019;s actions.",name:"system_prompt"},{anchor:"smolagents.ToolCallingAgent.planning_interval",description:"<strong>planning_interval</strong> (<code>int</code>, <em>optional</em>) &#x2014; Interval at which the agent will run a planning step.",name:"planning_interval"},{anchor:"smolagents.ToolCallingAgent.*kwargs",description:"*<strong>*kwargs</strong> &#x2014; Additional keyword arguments.",name:"*kwargs"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L642"}}),ht=new C({props:{name:"step",anchor:"smolagents.ToolCallingAgent.step",parameters:[{name:"memory_step",val:": ActionStep"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L673"}}),ft=new Yt({props:{title:"ManagedAgent",local:"smolagents.ManagedAgent",headingTag:"h3"}}),_t=new C({props:{name:"class smolagents.ManagedAgent",anchor:"smolagents.ManagedAgent",parameters:[{name:"agent",val:""},{name:"name",val:""},{name:"description",val:""},{name:"additional_prompting",val:": typing.Optional[str] = None"},{name:"provide_run_summary",val:": bool = False"},{name:"managed_agent_prompt",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"smolagents.ManagedAgent.agent",description:"<strong>agent</strong> (<code>object</code>) &#x2014; The agent to be managed.",name:"agent"},{anchor:"smolagents.ManagedAgent.name",description:"<strong>name</strong> (<code>str</code>) &#x2014; The name of the managed agent.",name:"name"},{anchor:"smolagents.ManagedAgent.description",description:"<strong>description</strong> (<code>str</code>) &#x2014; A description of the managed agent.",name:"description"},{anchor:"smolagents.ManagedAgent.additional_prompting",description:"<strong>additional_prompting</strong> (<code>Optional[str]</code>, <em>optional</em>) &#x2014; Additional prompting for the managed agent. Defaults to None.",name:"additional_prompting"},{anchor:"smolagents.ManagedAgent.provide_run_summary",description:"<strong>provide_run_summary</strong> (<code>bool</code>, <em>optional</em>) &#x2014; Whether to provide a run summary after the agent completes its task. Defaults to False.",name:"provide_run_summary"},{anchor:"smolagents.ManagedAgent.managed_agent_prompt",description:"<strong>managed_agent_prompt</strong> (<code>Optional[str]</code>, <em>optional</em>) &#x2014; Custom prompt for the managed agent. Defaults to None.",name:"managed_agent_prompt"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L931"}}),vt=new C({props:{name:"write_full_task",anchor:"smolagents.ManagedAgent.write_full_task",parameters:[{name:"task",val:""}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/agents.py#L961"}}),$t=new Yt({props:{title:"stream_to_gradio",local:"smolagents.stream_to_gradio",headingTag:"h3"}}),bt=new C({props:{name:"smolagents.stream_to_gradio",anchor:"smolagents.stream_to_gradio",parameters:[{name:"agent",val:""},{name:"task",val:": str"},{name:"reset_agent_memory",val:": bool = False"},{name:"additional_args",val:": typing.Optional[dict] = None"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/gradio_ui.py#L126"}}),xt=new Yt({props:{title:"GradioUI",local:"smolagents.GradioUI",headingTag:"h3"}}),J=new Nn({props:{warning:!1,$$slots:{default:[Bn]},$$scope:{ctx:E}}}),yt=new C({props:{name:"class smolagents.GradioUI",anchor:"smolagents.GradioUI",parameters:[{name:"agent",val:": MultiStepAgent"},{name:"file_upload_folder",val:": str | None = None"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/gradio_ui.py#L178"}}),Ct=new C({props:{name:"upload_file",anchor:"smolagents.GradioUI.upload_file",parameters:[{name:"file",val:""},{name:"file_uploads_log",val:""},{name:"allowed_file_types",val:" = ['application/pdf', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'text/plain']"}],source:"https://github.com/huggingface/smolagents/blob/vr_459/src/smolagents/gradio_ui.py#L202"}}),At=new Gn({props:{source:"https://github.com/huggingface/smolagents/blob/main/docs/source/en/reference/agents.md"}}),{c(){g=r("meta"),M=a(),$=r("p"),A=a(),m(w.$$.fragment),y=a(),m(L.$$.fragment),Kt=a(),Z=r("p"),Z.innerHTML=pn,te=a(),m(Q.$$.fragment),ee=a(),Y=r("p"),Y.innerHTML=dn,ne=a(),X=r("p"),X.innerHTML=cn,ae=a(),K=r("ul"),K.innerHTML=un,se=a(),tt=r("p"),tt.innerHTML=hn,oe=a(),m(et.$$.fragment),re=a(),f=r("div"),m(nt.$$.fragment),Se=a(),Lt=r("p"),Lt.textContent=fn,De=a(),N=r("div"),m(at.$$.fragment),Pe=a(),kt=r("p"),kt.textContent=_n,Ie=a(),O=r("div"),m(st.$$.fragment),Ee=a(),Tt=r("p"),Tt.textContent=vn,Ne=a(),V=r("div"),m(ot.$$.fragment),Oe=a(),St=r("p"),St.textContent=$n,Ve=a(),z=r("div"),m(rt.$$.fragment),ze=a(),Dt=r("p"),Dt.textContent=bn,Ue=a(),U=r("div"),m(lt.$$.fragment),He=a(),Pt=r("p"),Pt.textContent=xn,je=a(),P=r("div"),m(it.$$.fragment),Fe=a(),It=r("p"),It.textContent=yn,Ge=a(),m(H.$$.fragment),Re=a(),j=r("div"),m(gt.$$.fragment),We=a(),Et=r("p"),Et.textContent=Cn,Be=a(),F=r("div"),m(mt.$$.fragment),Je=a(),Nt=r("p"),Nt.textContent=An,qe=a(),G=r("div"),m(pt.$$.fragment),Ze=a(),Ot=r("p"),Ot.textContent=Mn,le=a(),k=r("div"),m(dt.$$.fragment),Qe=a(),Vt=r("p"),Vt.textContent=wn,Ye=a(),R=r("div"),m(ct.$$.fragment),Xe=a(),zt=r("p"),zt.textContent=Ln,ie=a(),T=r("div"),m(ut.$$.fragment),Ke=a(),Ut=r("p"),Ut.innerHTML=kn,tn=a(),W=r("div"),m(ht.$$.fragment),en=a(),Ht=r("p"),Ht.textContent=Tn,ge=a(),m(ft.$$.fragment),me=a(),S=r("div"),m(_t.$$.fragment),nn=a(),jt=r("p"),jt.textContent=Sn,an=a(),B=r("div"),m(vt.$$.fragment),sn=a(),Ft=r("p"),Ft.textContent=Dn,pe=a(),m($t.$$.fragment),de=a(),I=r("div"),m(bt.$$.fragment),on=a(),Gt=r("p"),Gt.textContent=Pn,ce=a(),m(xt.$$.fragment),ue=a(),m(J.$$.fragment),he=a(),D=r("div"),m(yt.$$.fragment),rn=a(),Rt=r("p"),Rt.textContent=In,ln=a(),q=r("div"),m(Ct.$$.fragment),gn=a(),Wt=r("p"),Wt.textContent=En,fe=a(),m(At.$$.fragment),_e=a(),Xt=r("p"),this.h()},l(t){const o=Hn("svelte-u9bgzb",document.head);g=l(o,"META",{name:!0,content:!0}),o.forEach(n),M=s(t),$=l(t,"P",{}),b($).forEach(n),A=s(t),p(w.$$.fragment,t),y=s(t),p(L.$$.fragment,t),Kt=s(t),Z=l(t,"P",{"data-svelte-h":!0}),_(Z)!=="svelte-17nnzxz"&&(Z.innerHTML=pn),te=s(t),p(Q.$$.fragment,t),ee=s(t),Y=l(t,"P",{"data-svelte-h":!0}),_(Y)!=="svelte-1and6si"&&(Y.innerHTML=dn),ne=s(t),X=l(t,"P",{"data-svelte-h":!0}),_(X)!=="svelte-18joafb"&&(X.innerHTML=cn),ae=s(t),K=l(t,"UL",{"data-svelte-h":!0}),_(K)!=="svelte-16e7y85"&&(K.innerHTML=un),se=s(t),tt=l(t,"P",{"data-svelte-h":!0}),_(tt)!=="svelte-1pp7p5a"&&(tt.innerHTML=hn),oe=s(t),p(et.$$.fragment,t),re=s(t),f=l(t,"DIV",{class:!0});var v=b(f);p(nt.$$.fragment,v),Se=s(v),Lt=l(v,"P",{"data-svelte-h":!0}),_(Lt)!=="svelte-d5y990"&&(Lt.textContent=fn),De=s(v),N=l(v,"DIV",{class:!0});var Mt=b(N);p(at.$$.fragment,Mt),Pe=s(Mt),kt=l(Mt,"P",{"data-svelte-h":!0}),_(kt)!=="svelte-a91m64"&&(kt.textContent=_n),Mt.forEach(n),Ie=s(v),O=l(v,"DIV",{class:!0});var wt=b(O);p(st.$$.fragment,wt),Ee=s(wt),Tt=l(wt,"P",{"data-svelte-h":!0}),_(Tt)!=="svelte-104knry"&&(Tt.textContent=vn),wt.forEach(n),Ne=s(v),V=l(v,"DIV",{class:!0});var $e=b(V);p(ot.$$.fragment,$e),Oe=s($e),St=l($e,"P",{"data-svelte-h":!0}),_(St)!=="svelte-e54ku6"&&(St.textContent=$n),$e.forEach(n),Ve=s(v),z=l(v,"DIV",{class:!0});var be=b(z);p(rt.$$.fragment,be),ze=s(be),Dt=l(be,"P",{"data-svelte-h":!0}),_(Dt)!=="svelte-s6zvq5"&&(Dt.textContent=bn),be.forEach(n),Ue=s(v),U=l(v,"DIV",{class:!0});var xe=b(U);p(lt.$$.fragment,xe),He=s(xe),Pt=l(xe,"P",{"data-svelte-h":!0}),_(Pt)!=="svelte-28znqy"&&(Pt.textContent=xn),xe.forEach(n),je=s(v),P=l(v,"DIV",{class:!0});var Bt=b(P);p(it.$$.fragment,Bt),Fe=s(Bt),It=l(Bt,"P",{"data-svelte-h":!0}),_(It)!=="svelte-1rclfo7"&&(It.textContent=yn),Ge=s(Bt),p(H.$$.fragment,Bt),Bt.forEach(n),Re=s(v),j=l(v,"DIV",{class:!0});var ye=b(j);p(gt.$$.fragment,ye),We=s(ye),Et=l(ye,"P",{"data-svelte-h":!0}),_(Et)!=="svelte-1dm4vwt"&&(Et.textContent=Cn),ye.forEach(n),Be=s(v),F=l(v,"DIV",{class:!0});var Ce=b(F);p(mt.$$.fragment,Ce),Je=s(Ce),Nt=l(Ce,"P",{"data-svelte-h":!0}),_(Nt)!=="svelte-em4ik4"&&(Nt.textContent=An),Ce.forEach(n),qe=s(v),G=l(v,"DIV",{class:!0});var Ae=b(G);p(pt.$$.fragment,Ae),Ze=s(Ae),Ot=l(Ae,"P",{"data-svelte-h":!0}),_(Ot)!=="svelte-jg60qx"&&(Ot.textContent=Mn),Ae.forEach(n),v.forEach(n),le=s(t),k=l(t,"DIV",{class:!0});var Jt=b(k);p(dt.$$.fragment,Jt),Qe=s(Jt),Vt=l(Jt,"P",{"data-svelte-h":!0}),_(Vt)!=="svelte-1mxsa12"&&(Vt.textContent=wn),Ye=s(Jt),R=l(Jt,"DIV",{class:!0});var Me=b(R);p(ct.$$.fragment,Me),Xe=s(Me),zt=l(Me,"P",{"data-svelte-h":!0}),_(zt)!=="svelte-e31bwu"&&(zt.textContent=Ln),Me.forEach(n),Jt.forEach(n),ie=s(t),T=l(t,"DIV",{class:!0});var qt=b(T);p(ut.$$.fragment,qt),Ke=s(qt),Ut=l(qt,"P",{"data-svelte-h":!0}),_(Ut)!=="svelte-71yyi1"&&(Ut.innerHTML=kn),tn=s(qt),W=l(qt,"DIV",{class:!0});var we=b(W);p(ht.$$.fragment,we),en=s(we),Ht=l(we,"P",{"data-svelte-h":!0}),_(Ht)!=="svelte-e31bwu"&&(Ht.textContent=Tn),we.forEach(n),qt.forEach(n),ge=s(t),p(ft.$$.fragment,t),me=s(t),S=l(t,"DIV",{class:!0});var Zt=b(S);p(_t.$$.fragment,Zt),nn=s(Zt),jt=l(Zt,"P",{"data-svelte-h":!0}),_(jt)!=="svelte-1stgzrz"&&(jt.textContent=Sn),an=s(Zt),B=l(Zt,"DIV",{class:!0});var Le=b(B);p(vt.$$.fragment,Le),sn=s(Le),Ft=l(Le,"P",{"data-svelte-h":!0}),_(Ft)!=="svelte-bdrkn8"&&(Ft.textContent=Dn),Le.forEach(n),Zt.forEach(n),pe=s(t),p($t.$$.fragment,t),de=s(t),I=l(t,"DIV",{class:!0});var ke=b(I);p(bt.$$.fragment,ke),on=s(ke),Gt=l(ke,"P",{"data-svelte-h":!0}),_(Gt)!=="svelte-3yyclm"&&(Gt.textContent=Pn),ke.forEach(n),ce=s(t),p(xt.$$.fragment,t),ue=s(t),p(J.$$.fragment,t),he=s(t),D=l(t,"DIV",{class:!0});var Qt=b(D);p(yt.$$.fragment,Qt),rn=s(Qt),Rt=l(Qt,"P",{"data-svelte-h":!0}),_(Rt)!=="svelte-1yrmsm6"&&(Rt.textContent=In),ln=s(Qt),q=l(Qt,"DIV",{class:!0});var Te=b(q);p(Ct.$$.fragment,Te),gn=s(Te),Wt=l(Te,"P",{"data-svelte-h":!0}),_(Wt)!=="svelte-1m7n73n"&&(Wt.textContent=En),Te.forEach(n),Qt.forEach(n),fe=s(t),p(At.$$.fragment,t),_e=s(t),Xt=l(t,"P",{}),b(Xt).forEach(n),this.h()},h(){x(g,"name","hf:doc:metadata"),x(g,"content",qn),x(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,o){e(document.head,g),i(t,M,o),i(t,$,o),i(t,A,o),d(w,t,o),i(t,y,o),d(L,t,o),i(t,Kt,o),i(t,Z,o),i(t,te,o),d(Q,t,o),i(t,ee,o),i(t,Y,o),i(t,ne,o),i(t,X,o),i(t,ae,o),i(t,K,o),i(t,se,o),i(t,tt,o),i(t,oe,o),d(et,t,o),i(t,re,o),i(t,f,o),d(nt,f,null),e(f,Se),e(f,Lt),e(f,De),e(f,N),d(at,N,null),e(N,Pe),e(N,kt),e(f,Ie),e(f,O),d(st,O,null),e(O,Ee),e(O,Tt),e(f,Ne),e(f,V),d(ot,V,null),e(V,Oe),e(V,St),e(f,Ve),e(f,z),d(rt,z,null),e(z,ze),e(z,Dt),e(f,Ue),e(f,U),d(lt,U,null),e(U,He),e(U,Pt),e(f,je),e(f,P),d(it,P,null),e(P,Fe),e(P,It),e(P,Ge),d(H,P,null),e(f,Re),e(f,j),d(gt,j,null),e(j,We),e(j,Et),e(f,Be),e(f,F),d(mt,F,null),e(F,Je),e(F,Nt),e(f,qe),e(f,G),d(pt,G,null),e(G,Ze),e(G,Ot),i(t,le,o),i(t,k,o),d(dt,k,null),e(k,Qe),e(k,Vt),e(k,Ye),e(k,R),d(ct,R,null),e(R,Xe),e(R,zt),i(t,ie,o),i(t,T,o),d(ut,T,null),e(T,Ke),e(T,Ut),e(T,tn),e(T,W),d(ht,W,null),e(W,en),e(W,Ht),i(t,ge,o),d(ft,t,o),i(t,me,o),i(t,S,o),d(_t,S,null),e(S,nn),e(S,jt),e(S,an),e(S,B),d(vt,B,null),e(B,sn),e(B,Ft),i(t,pe,o),d($t,t,o),i(t,de,o),i(t,I,o),d(bt,I,null),e(I,on),e(I,Gt),i(t,ce,o),d(xt,t,o),i(t,ue,o),d(J,t,o),i(t,he,o),i(t,D,o),d(yt,D,null),e(D,rn),e(D,Rt),e(D,ln),e(D,q),d(Ct,q,null),e(q,gn),e(q,Wt),i(t,fe,o),d(At,t,o),i(t,_e,o),i(t,Xt,o),ve=!0},p(t,[o]){const v={};o&2&&(v.$$scope={dirty:o,ctx:t}),L.$set(v);const Mt={};o&2&&(Mt.$$scope={dirty:o,ctx:t}),H.$set(Mt);const wt={};o&2&&(wt.$$scope={dirty:o,ctx:t}),J.$set(wt)},i(t){ve||(c(w.$$.fragment,t),c(L.$$.fragment,t),c(Q.$$.fragment,t),c(et.$$.fragment,t),c(nt.$$.fragment,t),c(at.$$.fragment,t),c(st.$$.fragment,t),c(ot.$$.fragment,t),c(rt.$$.fragment,t),c(lt.$$.fragment,t),c(it.$$.fragment,t),c(H.$$.fragment,t),c(gt.$$.fragment,t),c(mt.$$.fragment,t),c(pt.$$.fragment,t),c(dt.$$.fragment,t),c(ct.$$.fragment,t),c(ut.$$.fragment,t),c(ht.$$.fragment,t),c(ft.$$.fragment,t),c(_t.$$.fragment,t),c(vt.$$.fragment,t),c($t.$$.fragment,t),c(bt.$$.fragment,t),c(xt.$$.fragment,t),c(J.$$.fragment,t),c(yt.$$.fragment,t),c(Ct.$$.fragment,t),c(At.$$.fragment,t),ve=!0)},o(t){u(w.$$.fragment,t),u(L.$$.fragment,t),u(Q.$$.fragment,t),u(et.$$.fragment,t),u(nt.$$.fragment,t),u(at.$$.fragment,t),u(st.$$.fragment,t),u(ot.$$.fragment,t),u(rt.$$.fragment,t),u(lt.$$.fragment,t),u(it.$$.fragment,t),u(H.$$.fragment,t),u(gt.$$.fragment,t),u(mt.$$.fragment,t),u(pt.$$.fragment,t),u(dt.$$.fragment,t),u(ct.$$.fragment,t),u(ut.$$.fragment,t),u(ht.$$.fragment,t),u(ft.$$.fragment,t),u(_t.$$.fragment,t),u(vt.$$.fragment,t),u($t.$$.fragment,t),u(bt.$$.fragment,t),u(xt.$$.fragment,t),u(J.$$.fragment,t),u(yt.$$.fragment,t),u(Ct.$$.fragment,t),u(At.$$.fragment,t),ve=!1},d(t){t&&(n(M),n($),n(A),n(y),n(Kt),n(Z),n(te),n(ee),n(Y),n(ne),n(X),n(ae),n(K),n(se),n(tt),n(oe),n(re),n(f),n(le),n(k),n(ie),n(T),n(ge),n(me),n(S),n(pe),n(de),n(I),n(ce),n(ue),n(he),n(D),n(fe),n(_e),n(Xt)),n(g),h(w,t),h(L,t),h(Q,t),h(et,t),h(nt),h(at),h(st),h(ot),h(rt),h(lt),h(it),h(H),h(gt),h(mt),h(pt),h(dt),h(ct),h(ut),h(ht),h(ft,t),h(_t),h(vt),h($t,t),h(bt),h(xt,t),h(J,t),h(yt),h(Ct),h(At,t)}}}const qn='{"title":"Agents","local":"agents","sections":[{"title":"Agents","local":"agents","sections":[{"title":"Classes of agents","local":"smolagents.MultiStepAgent","sections":[],"depth":3},{"title":"ManagedAgent","local":"smolagents.ManagedAgent","sections":[],"depth":3},{"title":"stream_to_gradio","local":"smolagents.stream_to_gradio","sections":[],"depth":3},{"title":"GradioUI","local":"smolagents.GradioUI","sections":[],"depth":3}],"depth":2}],"depth":1}';function Zn(E){return Vn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class na extends zn{constructor(g){super(),Un(this,g,Zn,Jn,On,{})}}export{na as component};
